----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

hudToggle = {}
local settingsFile = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
hudToggle.title = getXMLString(settingsFile, "modDesc.title.en");
hudToggle.author = getXMLString(settingsFile, "modDesc.author");
hudToggle.version = getXMLString(settingsFile, "modDesc.version");
delete(settingsFile);
print("Load mod: "..hudToggle.title.." : v"..hudToggle.version.." by "..hudToggle.author);


function hudToggle:loadMap(savegame)
	hudToggle.events = {};
    Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, hudToggle.registerActionEvents);
    Player.updateActionEvents = Utils.appendedFunction(Player.updateActionEvents, hudToggle.registerActionEvents);
	Player.removeActionEvents = Utils.appendedFunction(Player.removeActionEvents, hudToggle.removeActionEvents);
    Enterable.onRegisterActionEvents = Utils.appendedFunction(Enterable.onRegisterActionEvents, hudToggle.registerActionEvents);
end;

function hudToggle:removeActionEvents()
	hudToggle.events = {};
end;

function hudToggle:registerActionEvents()
	hudToggle.events = {};
	local result, eventName = InputBinding.registerActionEvent(g_inputBinding, "TOGGLEHUD", self, hudToggle.toggleHUD, false, true, false, true)
	if result then
		table.insert(hudToggle.events, eventName);
        g_inputBinding:setActionEventTextVisibility(eventName, true);
		g_inputBinding:setActionEventTextPriority(eventName, GS_PRIO_NORMAL);
    end;
end;

function hudToggle:toggleHUD(actionName, keyStatus, arg3, arg4, arg5)
	if actionName == "TOGGLEHUD" then		
		if g_currentMission.hud.isVisible then
			g_currentMission.hud:setIsVisible(false);
		else
			g_currentMission.hud:setIsVisible(true);
		end;
	end;
end;

addModEventListener(hudToggle);